// EDock (C)opyright 2007 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __WINDOWBUTTON_H__
#define __WINDOWBUTTON_H__

#include <gui/button.h>
#include <gui/image.h>

class WindowButton : public os::Button
{
public:
	WindowButton( os::Rect cFrame, const os::String& cName, const os::String& cLabel, os::Message* pcMessage, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP, uint32 nFlags = os::WID_WILL_DRAW | os::WID_FULL_UPDATE_ON_RESIZE );
	~WindowButton();

	void HandleMessage( os::Message* pcMessage );
	void Paint( const os::Rect& cUpdateRect );
	os::Point GetPreferredSize( bool bLargest ) const;
	void MouseDown( const os::Point& cPosition, uint32 nButtons );

	WindowButton* Duplicate();

	os::BitmapImage* GetImage();
	void SetImage( os::BitmapImage * pcBitmap );

	port_id GetMsgPort();
	void SetMsgPort( port_id hPort );
	os::String GetID();
	void SetID( os::String id );
	os::String GetTitle();
	void SetTitle( os::String zTitle );	
	int64 GetHandle();
	void SetHandle( int64 nHandle );
	bool GetVisible( uint32 nDesktopMask );
	void SetVisible( bool bVisible );
	bool GetMinimized();
	void SetMinimized( bool bMinimized );
	uint32 GetDesktopMask();
	void SetDesktopMask( uint32 nMask );

private:
	class _Private;
	_Private* m;
};


#endif
